import 'package:flutter/material.dart';
import 'package:flutter/services.dart';
import 'package:rtmptencent/rtmptencent.dart';

class LivePage extends StatefulWidget {
  @override
  _LivePageState createState() => _LivePageState();
}

class _LivePageState extends State<LivePage> {
  MethodChannel _controller;

  /// 按钮组建
  Widget _buttonList(Icon icons, String title, Function onClick) {
    return InkWell(
      child: Container(
        child: Column(
          children: <Widget>[
            icons,
            Text('$title'),
          ],
        ),
      ),
      onTap: onClick,
    );
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      body: Container(
        width: MediaQuery.of(context).size.width,
        height: MediaQuery.of(context).size.height,
        child: Stack(
          children: <Widget>[
            TencentLive(
                onCreated: (controller) {
                  _controller = controller;
                }
            ),
            Positioned(
              top: 0,
              left: 0,
              child: Container(
                width: MediaQuery.of(context).size.width,
                height: MediaQuery.of(context).size.height,
//                color: Colors.amber,
                child: SafeArea(
                    child: Stack(
                      children: <Widget>[
                        Text('data'),
                        Positioned(
                          bottom: 0,
                          left: 0,
                          child: Container(
                            padding: EdgeInsets.only(
                              left: 20.0,
                              right: 20.0,
                              bottom: 20.0,
                              top: 20.0,
                            ),
                            width: MediaQuery.of(context).size.width,
                            child: Row(
                              mainAxisAlignment: MainAxisAlignment.spaceAround,
                              children: <Widget>[
                                _buttonList(Icon(Icons.ac_unit), '翻转', () {
                                  _controller.invokeMethod('setSwitchCamera');
                                }),
                                _buttonList(Icon(Icons.ac_unit), '打开后置灯光', () {
                                  _controller.invokeMethod('setTurnOnFlashLight');
                                }),
                                _buttonList(Icon(Icons.ac_unit), '美颜', () {
                                  _controller.invokeMethod('setBeautyStyle', 1);
                                }),
                                _buttonList(Icon(Icons.ac_unit), '镜像模式', () {
                                  _controller.invokeMethod('setMirror', 1);
                                }),
                              ],
                            ),
                          ),
                        )
                      ],
                    )
                ),
              ),
            )
          ],
        ),
      ),
    );
  }
}
